# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`xzscanner`](#xzscanner)

### Tasks

* [`run_scan`](#run_scan): Runs script on target node to detect xz vulnerability (CVE-2024-3094)

## Classes

### <a name="xzscanner"></a>`xzscanner`

The xzscanner class.

#### Parameters

The following parameters are available in the `xzscanner` class:

* [`present`](#-xzscanner--present)
* [`scan_data_owner`](#-xzscanner--scan_data_owner)
* [`scan_data_group`](#-xzscanner--scan_data_group)
* [`cron_user`](#-xzscanner--cron_user)
* [`cron_hour`](#-xzscanner--cron_hour)
* [`cron_month`](#-xzscanner--cron_month)
* [`cron_monthday`](#-xzscanner--cron_monthday)
* [`cron_weekday`](#-xzscanner--cron_weekday)
* [`cron_minute`](#-xzscanner--cron_minute)
* [`ensure`](#-xzscanner--ensure)

##### <a name="-xzscanner--present"></a>`present`

Whether the scanner should be installed

##### <a name="-xzscanner--scan_data_owner"></a>`scan_data_owner`

Data type: `String`

Owner of the generated scan results

Default value: `'root'`

##### <a name="-xzscanner--scan_data_group"></a>`scan_data_group`

Data type: `String`

Group of the generated scan results

Default value: `'root'`

##### <a name="-xzscanner--cron_user"></a>`cron_user`

Data type: `String`



Default value: `'root'`

##### <a name="-xzscanner--cron_hour"></a>`cron_hour`

Data type: `Any`



Default value: `absent`

##### <a name="-xzscanner--cron_month"></a>`cron_month`

Data type: `Any`



Default value: `absent`

##### <a name="-xzscanner--cron_monthday"></a>`cron_monthday`

Data type: `Any`



Default value: `absent`

##### <a name="-xzscanner--cron_weekday"></a>`cron_weekday`

Data type: `Any`



Default value: `absent`

##### <a name="-xzscanner--cron_minute"></a>`cron_minute`

Data type: `Any`



Default value: `fqdn_rand(59)`

##### <a name="-xzscanner--ensure"></a>`ensure`

Data type: `Enum['present', 'absent']`



Default value: `'present'`

## Tasks

### <a name="run_scan"></a>`run_scan`

Runs script on target node to detect xz vulnerability (CVE-2024-3094)

**Supports noop?** false

